restrict upload to role teacher

This commit is contained in:
Raphael Dannecker 2023-07-13 15:44:17 +02:00
parent 982ea9464d
commit d88d9fb428
4 changed files with 65 additions and 44 deletions

View file

@ -0,0 +1 @@
%role-teacher ALL=(root) NOPASSWD: /usr/local/bin/upload-vm.sh

View file

@ -4,51 +4,14 @@ set -eu
show_help() { show_help() {
cat << EOF >&2 cat << EOF >&2
Usage: $(basename "$0") [-u vmname] [-d vmname] [-a] [-t]" Usage: $(basename "$0") [-d vmname] [-a] [-t]"
When using option -u (upload), the disk from VM vmname will be synced on server. The images from images.list and xml-directory will be synced from server.
Otherwise the images from images.list and xml-directory will be synced from server.
Using flag -t all torrents and xml-VM-Definitions will be synced Using flag -t all torrents and xml-VM-Definitions will be synced
EOF EOF
} }
VM_DIR="/tmp/${SUDO_UID}/vmimages" VM_DIR="/tmp/${SUDO_UID}/vmimages"
upload_image() {
# check if VM-Diskimage exists
if [[ ! (-f "/var/lib/libvirt/images/${VM_NAME}.qcow2" || -f "${VM_DIR}/${VM_NAME}.qcow2") ]]; then
echo "File not found ${VM_NAME}.qcow2" >&2
exit 1
fi
# link private VM-Diskimage to system-Dir
if [[ -f "${VM_DIR}/${VM_NAME}.qcow2" \
&& ( -f "/var/lib/libvirt/images/${VM_NAME}.qcow2" && ("${VM_DIR}/${VM_NAME}.qcow2" -nt "/var/lib/libvirt/images/${VM_NAME}.qcow2") \
|| ! -f "/var/lib/libvirt/images/${VM_NAME}.qcow2") ]]; then
echo "copy private VM-Diskimage to system-dir"
ln -f "${VM_DIR}/${VM_NAME}.qcow2" "/var/lib/libvirt/images/${VM_NAME}.qcow2"
fi
# check if VM-Machine-Definition XML exists
if [[ ! (-f "/var/lib/libvirt/images/xml/${VM_NAME}.xml" || -f "${VM_DIR}/xml/${VM_NAME}.xml") ]]; then
echo "File not found ${VM_NAME}.xml" >&2
exit 1
fi
# copy private VM-Maschine-Definition XML to system-Dir
if [[ -f "${VM_DIR}/xml/${VM_NAME}.xml" \
&& ( -f "/var/lib/libvirt/images/xml/${VM_NAME}.xml" && $(cmp -s "${VM_DIR}/xml/${VM_NAME}.xml" "/var/lib/libvirt/images/xml/${VM_NAME}.xml") \
|| ! -f "/var/lib/libvirt/images/xml/${VM_NAME}.xml") ]]; then
echo "copy private VM-Maschine-Definition XML to system-dir"
cp "${VM_DIR}/xml/${VM_NAME}.xml" "/var/lib/libvirt/images/xml/"
fi
# (re-) create torrent file
/usr/local/bin/vmimage-torrent create "${VM_NAME}.qcow2"
# Upload Torrent, qcow2 and machine-definition-XML
[[ -f "/var/lib/libvirt/images/${VM_NAME}.qcow2.torrent" ]] && rsync -av --password-file=/etc/rsync.secret \
"/var/lib/libvirt/images/${VM_NAME}.qcow2.torrent" rsync://vmuser@server:/vmimages-upload/
rsync -av --password-file=/etc/rsync.secret "/var/lib/libvirt/images/${VM_NAME}.qcow2" \
rsync://vmuser@server:/vmimages-upload/
rsync -av --password-file=/etc/rsync.secret "/var/lib/libvirt/images/xml/${VM_NAME}.xml" \
rsync://vmuser@server:/vmimages-upload/xml/
}
download_image() { download_image() {
if [[ -f "/var/lib/libvirt/images/${VM_NAME}.qcow2.torrent" ]]; then if [[ -f "/var/lib/libvirt/images/${VM_NAME}.qcow2.torrent" ]]; then
cd /var/lib/libvirt/images cd /var/lib/libvirt/images
@ -78,12 +41,8 @@ sync_all_torrents() {
/var/lib/libvirt/images/ /var/lib/libvirt/images/
} }
while getopts ':u:d:at' OPTION; do while getopts ':d:at' OPTION; do
case "$OPTION" in case "$OPTION" in
u)
VM_NAME=$OPTARG
upload_image
;;
d) d)
VM_NAME=$OPTARG VM_NAME=$OPTARG
download_image download_image

59
roles/lmn_vm/files/upload-vm.sh Executable file
View file

@ -0,0 +1,59 @@
#!/usr/bin/bash
# Push VM-Disk-Image on server
set -eu
show_help() {
cat << EOF >&2
Usage: $(basename "$0") vmname"
Create torrent and upload disk, torrent and xml-VM-Definiton on server.
EOF
}
VM_DIR="/tmp/${SUDO_UID}/vmimages"
upload_image() {
# check if VM-Diskimage exists
if [[ ! (-f "/var/lib/libvirt/images/${VM_NAME}.qcow2" || -f "${VM_DIR}/${VM_NAME}.qcow2") ]]; then
echo "File not found ${VM_NAME}.qcow2" >&2
exit 1
fi
# link private VM-Diskimage to system-Dir
if [[ -f "${VM_DIR}/${VM_NAME}.qcow2" \
&& ( -f "/var/lib/libvirt/images/${VM_NAME}.qcow2" && ("${VM_DIR}/${VM_NAME}.qcow2" -nt "/var/lib/libvirt/images/${VM_NAME}.qcow2") \
|| ! -f "/var/lib/libvirt/images/${VM_NAME}.qcow2") ]]; then
echo "copy private VM-Diskimage to system-dir"
ln -f "${VM_DIR}/${VM_NAME}.qcow2" "/var/lib/libvirt/images/${VM_NAME}.qcow2"
fi
# check if VM-Machine-Definition XML exists
if [[ ! (-f "/var/lib/libvirt/images/xml/${VM_NAME}.xml" || -f "${VM_DIR}/xml/${VM_NAME}.xml") ]]; then
echo "File not found ${VM_NAME}.xml" >&2
exit 1
fi
# copy private VM-Maschine-Definition XML to system-Dir
if [[ -f "${VM_DIR}/xml/${VM_NAME}.xml" \
&& ( -f "/var/lib/libvirt/images/xml/${VM_NAME}.xml" && $(cmp -s "${VM_DIR}/xml/${VM_NAME}.xml" "/var/lib/libvirt/images/xml/${VM_NAME}.xml") \
|| ! -f "/var/lib/libvirt/images/xml/${VM_NAME}.xml") ]]; then
echo "copy private VM-Maschine-Definition XML to system-dir"
cp "${VM_DIR}/xml/${VM_NAME}.xml" "/var/lib/libvirt/images/xml/"
fi
cd /var/lib/libvirt/images
# (re-) create torrent file
/usr/local/bin/vmimage-torrent create "${VM_NAME}.qcow2"
# Upload Torrent, qcow2 and machine-definition-XML
[[ -f "/var/lib/libvirt/images/${VM_NAME}.qcow2.torrent" ]] && rsync -av --password-file=/etc/rsync.secret \
"/var/lib/libvirt/images/${VM_NAME}.qcow2.torrent" rsync://vmuser@server:/vmimages-upload/
rsync -av --password-file=/etc/rsync.secret "/var/lib/libvirt/images/${VM_NAME}.qcow2" \
rsync://vmuser@server:/vmimages-upload/
rsync -av --password-file=/etc/rsync.secret "/var/lib/libvirt/images/xml/${VM_NAME}.xml" \
rsync://vmuser@server:/vmimages-upload/xml/
}
# if less than one arguments supplied, display usage
if [[ $# -ne 1 ]] ; then
show_help
exit 1
fi
VM_NAME=$1
upload_image

View file

@ -60,6 +60,7 @@
loop: loop:
- lmn-mounthome - lmn-mounthome
- lmn-sync-vm - lmn-sync-vm
- lmn-upload-vm
- lmn-link-images - lmn-link-images
- lmn-startvirtiofsd - lmn-startvirtiofsd
@ -76,6 +77,7 @@
- rebase-vm.sh - rebase-vm.sh
- create-clone.sh - create-clone.sh
- run-vm.sh - run-vm.sh
- upload-vm.sh
- sync-vm.sh - sync-vm.sh
- link-images.sh - link-images.sh
- start-virtiofsd.sh - start-virtiofsd.sh